OGRE: Ogre::Texture Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::Texture Class Reference

Abstract class representing a Texture resource. More...

`#include <OgreTexture.h>`

Inheritance diagram for Ogre::Texture:

[legend]
List of all members.

## Public Types

enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions

| Texture (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
virtual void | setTextureType (TextureType ttype)
| Sets the type of texture; can only be changed before load().
virtual TextureType | getTextureType (void) const
| Gets the type of texture.
virtual size_t | getNumMipmaps (void) const
| Gets the number of mipmaps to be used for this texture.
virtual void | setNumMipmaps (size_t num)
| Sets the number of mipmaps to be used for this texture.
virtual bool | getMipmapsHardwareGenerated (void) const
| Are mipmaps hardware generated?
virtual float | getGamma (void) const
| Returns the gamma adjustment factor applied to this texture.
virtual void | setGamma (float g)
| Sets the gamma adjustment factor applied to this texture.
virtual size_t | getHeight (void) const
| Returns the height of the texture.
virtual size_t | getWidth (void) const
| Returns the width of the texture.
virtual size_t | getDepth (void) const
| Returns the depth of the texture (only applicable for 3D textures).
virtual size_t | getSrcHeight (void) const
| Returns the height of the original input texture (may differ due to hardware requirements).
virtual size_t | getSrcWidth (void) const
| Returns the width of the original input texture (may differ due to hardware requirements).
virtual size_t | getSrcDepth (void) const
| Returns the original depth of the input texture (only applicable for 3D textures).
virtual void | setHeight (size_t h)
| Set the height of the texture; can only do this before load();.
virtual void | setWidth (size_t w)
| Set the width of the texture; can only do this before load();.
virtual void | setDepth (size_t d)
| Set the depth of the texture (only applicable for 3D textures); ; can only do this before load();.
virtual int | getUsage () const
| Returns the TextureUsage indentifier for this Texture.
virtual void | setUsage (int u)
| Sets the TextureUsage indentifier for this Texture; only useful before load().
virtual void | createInternalResources (void)
| Creates the internal texture resources for this texture.
virtual void | freeInternalResources (void)
| Frees internal texture resources for this texture.
virtual void | copyToTexture (TexturePtr &target)
| Copies (and maybe scales to fit) the contents of this texture to another texture.
virtual void | loadImage (const Image &img)
| Loads the data from an image.
virtual void | loadRawData (DataStreamPtr &stream, ushort uWidth, ushort uHeight, PixelFormat eFormat)
| Loads the data from a raw stream.
virtual void | _loadImages (const ConstImagePtrList &images)
| Internal method to load the texture from a set of images.
virtual PixelFormat | getFormat () const
| Returns the pixel format for the texture surface.
virtual PixelFormat | getDesiredFormat (void) const
| Returns the desired pixel format for the texture surface.
virtual PixelFormat | getSrcFormat (void) const
| Returns the pixel format of the original input texture (may differ due to hardware requirements and pixel format convertion).
virtual void | setFormat (PixelFormat pf)
| Sets the pixel format for the texture surface; can only be set before load().
virtual bool | hasAlpha (void) const
| Returns true if the texture has an alpha layer.
virtual void | setDesiredIntegerBitDepth (ushort bits)
| Sets desired bit depth for integer pixel format textures.
virtual ushort | getDesiredIntegerBitDepth (void) const
| gets desired bit depth for integer pixel format textures.
virtual void | setDesiredFloatBitDepth (ushort bits)
| Sets desired bit depth for float pixel format textures.
virtual ushort | getDesiredFloatBitDepth (void) const
| gets desired bit depth for float pixel format textures.
virtual void | setDesiredBitDepths (ushort integerBits, ushort floatBits)
| Sets desired bit depth for integer and float pixel format.
virtual void | setTreatLuminanceAsAlpha (bool asAlpha)
| Sets whether luminace pixel format will treated as alpha format when load this texture.
virtual bool | getTreatLuminanceAsAlpha (void) const
| Gets whether luminace pixel format will treated as alpha format when load this texture.
virtual size_t | getNumFaces () const
| Return the number of faces this texture has.
virtual HardwarePixelBufferSharedPtr | getBuffer (size_t face=0, size_t mipmap=0)=0
| Return hardware pixel buffer for a surface.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
const String & | getName (void) const
| Gets resource name.
ResourceHandle | getHandle (void) const
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
LoadingState | isLoading () const
| Returns whether the resource is currently in the process of background loading.
LoadingState | getLoadingState () const
| Returns the current loading state.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
void | escalateLoading ()
| Escalates the loading of a background loaded resource.
void | addListener (Listener *lis)
| Register a listener on this resource.
void | removeListener (Listener *lis)
| Remove a listener on this resource.
const String & | getGroup (void)
| Gets the group which this resource is a member of.
void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | _fireBackgroundLoadingComplete (void)
| Firing of background loading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Member Functions

static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Protected Types

typedef std::list< Listener * > | ListenerList

## Protected Member Functions

size_t | calculateSize (void) const
virtual void | createInternalResourcesImpl (void)=0
| Implementation of creating internal texture resources.
virtual void | freeInternalResourcesImpl (void)=0
| Implementation of freeing internal texture resources.
void | unloadImpl (void)
| Default implementation of unload which calls freeInternalResources.
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | loadImpl (void)=0
| Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.
virtual void | queueFireBackgroundLoadingComplete (void)
| Queue the firing of background loading complete event.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

size_t | mHeight
size_t | mWidth
size_t | mDepth
size_t | mNumRequestedMipmaps
size_t | mNumMipmaps
bool | mMipmapsHardwareGenerated
float | mGamma
TextureType | mTextureType
PixelFormat | mFormat
int | mUsage
PixelFormat | mSrcFormat
size_t | mSrcWidth
size_t | mSrcHeight
size_t | mSrcDepth
PixelFormat | mDesiredFormat
unsigned short | mDesiredIntegerBitDepth
unsigned short | mDesiredFloatBitDepth
bool | mTreatLuminanceAsAlpha
bool | mInternalResourcesCreated
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
volatile LoadingState | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| Mutex to cover the status of loading The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
ListenerList | mListenerList
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Detailed Description

Abstract class representing a Texture resource.

Remarks:
  The actual concrete subclass which will exist for a texture is dependent on the rendering system in use (Direct3D, OpenGL etc). This class represents the commonalities, and is the one 'used' by programmers even though the real implementation could be different in reality. Texture objects are created through the 'create' method of the TextureManager concrete subclass.

Definition at line 96 of file OgreTexture.h.

## Member Typedef Documentation

typedef std::list<Listener*> Ogre::Resource::ListenerList`[protected, inherited]`

| Definition at line 131 of file OgreResource.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumeration values:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.

Definition at line 96 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::Texture::Texture | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |

## Member Function Documentation

virtual void Ogre::Resource::_fireBackgroundLoadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of background loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

virtual void Ogre::Texture::_loadImages | ( | const ConstImagePtrList & | images | ) | `[virtual]`

Internal method to load the texture from a set of images.

Note:
  Do NOT call this method unless you are inside the load() routine already, e.g. a ManualResourceLoader. It is not threadsafe and does not check or update resource loading status.

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[inherited]`

| Notify this resource of it's origin. Definition at line 358 of file OgreResource.h.

void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

size_t Ogre::Texture::calculateSize | ( | void |  | ) | const`[protected, virtual]`

| Implements Ogre::Resource.

void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs.

virtual void Ogre::Texture::copyToTexture | ( | TexturePtr & | target | ) | `[virtual]`

| Copies (and maybe scales to fit) the contents of this texture to another texture.

virtual void Ogre::Texture::createInternalResources | ( | void |  | ) | `[virtual]`

Creates the internal texture resources for this texture.

Remarks:
  This method creates the internal texture resources (pixel buffers, texture surfaces etc) required to begin using this texture. You do not need to call this method directly unless you are manually creating a texture, in which case something must call it, after having set the size and format of the texture (e.g. the ManualResourceLoader might be the best one to call it). If you are not defining a manual texture, or if you use one of the self-contained load...() methods, then it will be called for you.

virtual void Ogre::Texture::createInternalResourcesImpl | ( | void |  | ) | `[protected, pure virtual]`

| Implementation of creating internal texture resources.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

void Ogre::Resource::escalateLoading | ( |  | ) | `[inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Texture::freeInternalResources | ( | void |  | ) | `[virtual]`

| Frees internal texture resources for this texture.

virtual void Ogre::Texture::freeInternalResourcesImpl | ( | void |  | ) | `[protected, pure virtual]`

| Implementation of freeing internal texture resources.

virtual HardwarePixelBufferSharedPtr Ogre::Texture::getBuffer | ( | size_t | face = `0`,
|  | size_t | mipmap = `0`
| ) | `[pure virtual]`

Return hardware pixel buffer for a surface.

This buffer can then be used to copy data from and to a particular level of the texture.

Parameters:

  | face | Face number, in case of a cubemap texture. Must be 0 for other types of textures. For cubemaps, this is one of +X (0), -X (1), +Y (2), -Y (3), +Z (4), -Z (5)
  | mipmap | Mipmap level. This goes from 0 for the first, largest mipmap level to getNumMipmaps()-1 for the smallest.

Returns:
  A shared pointer to a hardware pixel buffer

Remarks:
  The buffer is invalidated when the resource is unloaded or destroyed. Do not use it after the lifetime of the containing texture.

ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[inherited]`

| Gets the manager which created this resource. Definition at line 349 of file OgreResource.h.

virtual size_t Ogre::Texture::getDepth | ( | void |  | ) | const`[virtual]`

| Returns the depth of the texture (only applicable for 3D textures). Definition at line 146 of file OgreTexture.h.

virtual ushort Ogre::Texture::getDesiredFloatBitDepth | ( | void |  | ) | const`[virtual]`

| gets desired bit depth for float pixel format textures.

virtual PixelFormat Ogre::Texture::getDesiredFormat | ( | void |  | ) | const`[virtual]`

| Returns the desired pixel format for the texture surface. Definition at line 245 of file OgreTexture.h.

virtual ushort Ogre::Texture::getDesiredIntegerBitDepth | ( | void |  | ) | const`[virtual]`

| gets desired bit depth for integer pixel format textures.

virtual PixelFormat Ogre::Texture::getFormat | ( |  | ) | const`[virtual]`

| Returns the pixel format for the texture surface. Definition at line 239 of file OgreTexture.h.

virtual float Ogre::Texture::getGamma | ( | void |  | ) | const`[virtual]`

| Returns the gamma adjustment factor applied to this texture. Definition at line 128 of file OgreTexture.h.

const String& Ogre::Resource::getGroup | ( | void |  | ) | `[inherited]`

| Gets the group which this resource is a member of. Reimplemented in Ogre::SkeletonInstance. Definition at line 337 of file OgreResource.h.

ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[inherited]`

| Reimplemented in Ogre::SkeletonInstance. Definition at line 263 of file OgreResource.h.

virtual size_t Ogre::Texture::getHeight | ( | void |  | ) | const`[virtual]`

| Returns the height of the texture. Definition at line 138 of file OgreTexture.h.

LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[inherited]`

| Returns the current loading state. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 286 of file OgreResource.h.

virtual bool Ogre::Texture::getMipmapsHardwareGenerated | ( | void |  | ) | const`[virtual]`

Are mipmaps hardware generated?

Remarks:
  Will only be accurate after texture load, or createInternalResources

Definition at line 124 of file OgreTexture.h.

const String& Ogre::Resource::getName | ( | void |  | ) | const`[inherited]`

| Gets resource name. Reimplemented in Ogre::SkeletonInstance. Definition at line 258 of file OgreResource.h.

virtual size_t Ogre::Texture::getNumFaces | ( |  | ) | const`[virtual]`

| Return the number of faces this texture has. This will be 6 for a cubemap texture and 1 for a 1D, 2D or 3D one.

virtual size_t Ogre::Texture::getNumMipmaps | ( | void |  | ) | const`[virtual]`

| Gets the number of mipmaps to be used for this texture. Definition at line 112 of file OgreTexture.h.

const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 356 of file OgreResource.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 213 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

size_t Ogre::Resource::getSize | ( | void |  | ) | const`[inherited]`

| Retrieves info about the size of the resource. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 247 of file OgreResource.h.

virtual size_t Ogre::Texture::getSrcDepth | ( | void |  | ) | const`[virtual]`

| Returns the original depth of the input texture (only applicable for 3D textures). Definition at line 158 of file OgreTexture.h.

virtual PixelFormat Ogre::Texture::getSrcFormat | ( | void |  | ) | const`[virtual]`

| Returns the pixel format of the original input texture (may differ due to hardware requirements and pixel format convertion). Definition at line 253 of file OgreTexture.h.

virtual size_t Ogre::Texture::getSrcHeight | ( | void |  | ) | const`[virtual]`

| Returns the height of the original input texture (may differ due to hardware requirements). Definition at line 150 of file OgreTexture.h.

virtual size_t Ogre::Texture::getSrcWidth | ( | void |  | ) | const`[virtual]`

| Returns the width of the original input texture (may differ due to hardware requirements). Definition at line 154 of file OgreTexture.h.

virtual TextureType Ogre::Texture::getTextureType | ( | void |  | ) | const`[virtual]`

| Gets the type of texture. Definition at line 108 of file OgreTexture.h.

virtual bool Ogre::Texture::getTreatLuminanceAsAlpha | ( | void |  | ) | const`[virtual]`

| Gets whether luminace pixel format will treated as alpha format when load this texture.

virtual int Ogre::Texture::getUsage | ( |  | ) | const`[virtual]`

| Returns the TextureUsage indentifier for this Texture. Definition at line 175 of file OgreTexture.h.

virtual size_t Ogre::Texture::getWidth | ( | void |  | ) | const`[virtual]`

| Returns the width of the texture. Definition at line 142 of file OgreTexture.h.

virtual bool Ogre::Texture::hasAlpha | ( | void |  | ) | const`[virtual]`

| Returns true if the texture has an alpha layer.

bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 303 of file OgreResource.h.

bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource has been loaded, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 270 of file OgreResource.h.

LoadingState Ogre::Resource::isLoading | ( |  | ) | const`[inherited]`

| Returns whether the resource is currently in the process of background loading. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 279 of file OgreResource.h.

bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[inherited]`

| Is this resource manually loaded? Definition at line 235 of file OgreResource.h.

bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource is reloadable, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 228 of file OgreResource.h.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Texture::loadImage | ( | const Image & | img | ) | `[virtual]`

Loads the data from an image.

Note:
  Important: only call this from outside the load() routine of a Resource. Don't call it within (including ManualResourceLoader) - use _loadImages() instead. This method is designed to be external, performs locking and checks the load status before loading.

virtual void Ogre::Resource::loadImpl | ( | void |  | ) | `[protected, pure virtual, inherited]`

| Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader. Implemented in Ogre::Compositor, Ogre::Font, Ogre::GpuProgram, Ogre::HighLevelGpuProgram, Ogre::Material, Ogre::Mesh, Ogre::PatchMesh, Ogre::Skeleton, and Ogre::SkeletonInstance.

virtual void Ogre::Texture::loadRawData | ( | DataStreamPtr & | stream,
|  | ushort | uWidth,
|  | ushort | uHeight,
|  | PixelFormat | eFormat
| ) | `[virtual]`

Loads the data from a raw stream.

Note:
  Important: only call this from outside the load() routine of a Resource. Don't call it within (including ManualResourceLoader) - use _loadImages() instead. This method is designed to be external, performs locking and checks the load status before loading.

Parameters:

  | stream | Data stream containing the raw pixel data
  | uWidth | Width of the image
  | uHeight | Height of the image
  | eFormat | The format of the pixel data

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented in Ogre::Mesh.

Definition at line 156 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 166 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 149 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 161 of file OgreResource.h.

virtual void Ogre::Resource::queueFireBackgroundLoadingComplete | ( | void |  | ) | `[protected, virtual, inherited]`

| Queue the firing of background loading complete event.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 313 of file OgreResource.h.

virtual void Ogre::Texture::setDepth | ( | size_t | d | ) | `[virtual]`

| Set the depth of the texture (only applicable for 3D textures); ; can only do this before load();. Definition at line 171 of file OgreTexture.h.

virtual void Ogre::Texture::setDesiredBitDepths | ( | ushort | integerBits,
|  | ushort | floatBits
| ) | `[virtual]`

| Sets desired bit depth for integer and float pixel format.

virtual void Ogre::Texture::setDesiredFloatBitDepth | ( | ushort | bits | ) | `[virtual]`

Sets desired bit depth for float pixel format textures.

Note:
  Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.

virtual void Ogre::Texture::setDesiredIntegerBitDepth | ( | ushort | bits | ) | `[virtual]`

Sets desired bit depth for integer pixel format textures.

Note:
  Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.

virtual void Ogre::Texture::setFormat | ( | PixelFormat | pf | ) | `[virtual]`

| Sets the pixel format for the texture surface; can only be set before load().

virtual void Ogre::Texture::setGamma | ( | float | g | ) | `[virtual]`

Sets the gamma adjustment factor applied to this texture.

Note:
  Must be called before any 'load' method.

Definition at line 134 of file OgreTexture.h.

virtual void Ogre::Texture::setHeight | ( | size_t | h | ) | `[virtual]`

| Set the height of the texture; can only do this before load();. Definition at line 162 of file OgreTexture.h.

virtual void Ogre::Texture::setNumMipmaps | ( | size_t | num | ) | `[virtual]`

Sets the number of mipmaps to be used for this texture.

Note:
  Must be set before calling any 'load' method.

Definition at line 118 of file OgreTexture.h.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual void Ogre::Texture::setTextureType | ( | TextureType | ttype | ) | `[virtual]`

| Sets the type of texture; can only be changed before load(). Definition at line 104 of file OgreTexture.h.

virtual void Ogre::Texture::setTreatLuminanceAsAlpha | ( | bool | asAlpha | ) | `[virtual]`

| Sets whether luminace pixel format will treated as alpha format when load this texture.

virtual void Ogre::Texture::setUsage | ( | int | u | ) | `[virtual]`

Sets the TextureUsage indentifier for this Texture; only useful before load().

Parameters:

  | u | is a combination of TU_STATIC, TU_DYNAMIC, TU_WRITE_ONLY TU_AUTOMIPMAP and TU_RENDERTARGET (see TextureUsage enum). You are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY.

Definition at line 187 of file OgreTexture.h.

virtual void Ogre::Texture::setWidth | ( | size_t | w | ) | `[virtual]`

| Set the width of the texture; can only do this before load();. Definition at line 166 of file OgreTexture.h.

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

| 'Touches' the resource to indicate it has been used. Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

| Unloads the resource; this is not permanent, the resource can be reloaded later if required. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Texture::unloadImpl | ( | void |  | ) | `[protected, virtual]`

| Default implementation of unload which calls freeInternalResources. Implements Ogre::Resource.

## Member Data Documentation

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

| Creator. Definition at line 109 of file OgreResource.h.

size_t Ogre::Texture::mDepth`[protected]`

| Definition at line 320 of file OgreTexture.h.

unsigned short Ogre::Texture::mDesiredFloatBitDepth`[protected]`

| Definition at line 336 of file OgreTexture.h.

PixelFormat Ogre::Texture::mDesiredFormat`[protected]`

| Definition at line 334 of file OgreTexture.h.

unsigned short Ogre::Texture::mDesiredIntegerBitDepth`[protected]`

| Definition at line 335 of file OgreTexture.h.

PixelFormat Ogre::Texture::mFormat`[protected]`

| Definition at line 328 of file OgreTexture.h.

float Ogre::Texture::mGamma`[protected]`

| Definition at line 325 of file OgreTexture.h.

String Ogre::Resource::mGroup`[protected, inherited]`

| The name of the resource group. Definition at line 113 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

| Numeric handle for more efficient look up than name. Definition at line 115 of file OgreResource.h.

size_t Ogre::Texture::mHeight`[protected]`

| Definition at line 318 of file OgreTexture.h.

bool Ogre::Texture::mInternalResourcesCreated`[protected]`

| Definition at line 339 of file OgreTexture.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

| Is this resource going to be background loaded? Only applicable for multithreaded. Definition at line 119 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

| Is this file manually loaded? Definition at line 125 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

| Definition at line 132 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

| Optional manual loader; if provided, data is loaded from here instead of a file. Definition at line 129 of file OgreResource.h.

volatile LoadingState Ogre::Resource::mLoadingState`[protected, inherited]`

| Is the resource currently loaded? Definition at line 117 of file OgreResource.h.

bool Ogre::Texture::mMipmapsHardwareGenerated`[protected]`

| Definition at line 324 of file OgreTexture.h.

String Ogre::Resource::mName`[protected, inherited]`

| Unique name of the resource. Definition at line 111 of file OgreResource.h.

size_t Ogre::Texture::mNumMipmaps`[protected]`

| Definition at line 323 of file OgreTexture.h.

size_t Ogre::Texture::mNumRequestedMipmaps`[protected]`

| Definition at line 322 of file OgreTexture.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

| Origin of this resource (e.g. script name) - optional. Definition at line 127 of file OgreResource.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 164 of file OgreStringInterface.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

| Dictionary of parameters. Definition at line 161 of file OgreStringInterface.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

| Mutex to cover the status of loading The size of the resource in bytes. Definition at line 123 of file OgreResource.h.

size_t Ogre::Texture::mSrcDepth`[protected]`

| Definition at line 332 of file OgreTexture.h.

PixelFormat Ogre::Texture::mSrcFormat`[protected]`

| Definition at line 331 of file OgreTexture.h.

size_t Ogre::Texture::mSrcHeight`[protected]`

| Definition at line 332 of file OgreTexture.h.

size_t Ogre::Texture::mSrcWidth`[protected]`

| Definition at line 332 of file OgreTexture.h.

TextureType Ogre::Texture::mTextureType`[protected]`

| Definition at line 327 of file OgreTexture.h.

bool Ogre::Texture::mTreatLuminanceAsAlpha`[protected]`

| Definition at line 337 of file OgreTexture.h.

int Ogre::Texture::mUsage`[protected]`

| Definition at line 329 of file OgreTexture.h.

size_t Ogre::Texture::mWidth`[protected]`

| Definition at line 319 of file OgreTexture.h.

The documentation for this class was generated from the following file:

- OgreTexture.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:28 2008